#pragma once

#define USED_PORTMAP_TUNNEL (0)
/**
 * @brief WireGuard key 󳤶
 */
#define WG_KEY_MAX          (64)

/**
 * @brief ϵͳ
 */
#define NET_CARD_MAX        (32)

/**
 * @brief IP ַ󳤶(֧IPv6)
 */
#define MAX_IP_LEN          (48)

/**
 * @brief IP ַС
 */
#define MIN_IP_LEN          (7)

/**
 * @brief ַ󳤶(֧IPv6)
 */
#define MAX_NETCARD_NAME    (64)

/**
 * @brief SCG  ID
 * 
 */
typedef enum {
    WG_TUNNEL_SCG_ID = 3,    ///< 
    WG_CTRL_SCG_ID   = 4     ///< Ʒ
} SCG_SVR_ID;

/**
 * @brief Э
 * 
 */
typedef enum {
    CRYPTO_NONE   = 0,    ///< 
    CRYPTO_BASE64 = 1,    ///< BASE64 ַ
    CRYPTO_AES128 = 2,    ///< AES 128λԿ 
    CRYPTO_3DES   = 3,    ///< 3DES 
    CRYPTO_AES256 = 4,    ///< AES 256 λԿ
    CRYPTO_MAX,
} PROTO_CRYPTO_TYPE;

/**
 * @brief ״̬
 * 
 */
typedef enum {
    STATUS_DISCONNECTED = 0,            ///< ѶϿ
    STATUS_CONNECTING,                  ///< ڽ
    STATUS_CONNECTED,                   ///< Ӵ״̬
    STATUS_DISCONNECTING,               ///< ڶϿ
    STATUS_HARDWARE_NOT_PRESENT,        ///< ӵӲӿڿ (NIC) 
    STATUS_HARDWARE_DISABLED,           ///< ӵӲڣδ
    STATUS_HARDWARE_MALFUNCTION,        ///< ӵӲз˹
    STATUS_MEDIA_DISCONNECTED,          ///< ý壨£Ͽ
    STATUS_AUTHENTICATING,              ///< ڵȴ֤
    STATUS_AUTHENTICATION_SUCCEEDED,    ///< ֤ڴϳɹ
    STATUS_AUTHENTICATION_FAILED,       ///< ֤ʧ
    STATUS_INVALID_ADDRESS,             ///< ַЧ
    STATUS_CREDENTIALS_REQUIRED,        ///< Ҫȫƾ
    STATUS_ACTION_REQUIRED,             ///< Ҫ
    STATUS_ACTION_REQUIRED_RETRY,       ///< 
    STATUS_CONNECT_FAILED,              ///< ʧ
} NET_CONNECT_STATUS;

/**
 * @brief ־ȼ
 * 
 */
enum LOG_LEVEL {
    LOG_TRACE = 0,    ///< TRACE ־ȼ
    LOG_DEBUG,        ///< DEBUG ־ȼ
    LOG_INFO,         ///< INFO  ־ȼ
    LOG_WARN,         ///< WARN  ־ȼ
    LOG_ERROR,        ///< ERROR ־ȼ
    LOG_CRITICAL,     ///< CRITICAL ־ȼ
    LOG_OFF           ///< ر־
};

/**
 * @brief Hash 㷨
 * 
 */
typedef enum {
    HASH_MD2 = 0,    ///< MD2 HASH 㷨
    HASH_MD4,        ///< MD4 HASH 㷨
    HASH_MD5,        ///< MD5 HASH 㷨
    HASH_SHA1,       ///< SHA1 HASH 㷨
    HASH_SHA256,     ///< SHA256 HASH 㷨
    HASH_SHA384,     ///< SHA384 HASH 㷨
    HASH_SHA512      ///< SHA512 HASH 㷨
} HASH_TYPE;

/**
 * @brief 繲ģʽ
 * 
 */
typedef enum {
    ICS_SHARE_MODE = 0,    ///< Internet Share Mode(ICS) ģʽ
    NAT_SHARE_MODE = 1     ///< Net Address Translation(NAT) ģʽ
} NET_SHARE_MODE;

/** 
 *
 * @brief Ϣ
 */
typedef struct {
    int   vmId;                     ///< û ID
    CHAR  vmName[MAX_PATH];         ///< û
    CHAR  svrPublicKey[64];         ///< û˹Կ
    CHAR  vmNetwork[MAX_IP_LEN];    ///< ûַ
    CHAR  scgGateWay[MAX_PATH];     ///< û˽
    CHAR  scgTunnelGw[MAX_PATH];    ///< û
} VM_CFG, *PVM_CFG;

/** 
 *
 * @brief ͻûϢ
 */
typedef struct {
    int     scgCtrlAppId;              ///< ûؿ ID
    int     scgTunnelAppId;            ///< û ID
    CHAR    cliPrivateKey[64];         ///< ûͻ˽Կ
    CHAR    cliPublicKey[64];          ///< ûͻ˹Կ
    CHAR    cliAddress[MAX_IP_LEN];    ///< ûͻIPַ
    PVM_CFG pVMConfig;                 ///< ûб
    int     tolVM;                     ///< û
} USER_CLIENT_CONFIG, *PUSER_CLIENT_CONFIG;

typedef struct {
    int   svrListenPort;             ///< û˼˿
    CHAR  svrPrivateKey[64];         ///< û˹Կ
    CHAR  svrAddress[MAX_IP_LEN];    ///< û IP ַ
} USER_SERVER_CONFIG, *PUSER_SERVER_CONFIG;
